ParseNode subclass: #ReturnNode
	instanceVariableNames: 'expr pc '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Compiler'!
!ReturnNode commentStamp: '<historical>' prior: 0!
I represent an expression of the form ^expr.!


!ReturnNode methodsFor: 'initialize-release'!
expr: e

	expr _ e! !

!ReturnNode methodsFor: 'initialize-release'!
expr: e encoder: encoder sourceRange: range

	expr _ e.
	encoder noteSourceRange: range forNode: self! !


!ReturnNode methodsFor: 'converting'!
asReturnNode! !


!ReturnNode methodsFor: 'testing'!
isReturnSelf

	^expr == NodeSelf! !

!ReturnNode methodsFor: 'testing'!
isSpecialConstant

	^expr isSpecialConstant! !

!ReturnNode methodsFor: 'testing'!
isVariableReference

	^expr isVariableReference! !


!ReturnNode methodsFor: 'code generation'!
code

	^expr code! !

!ReturnNode methodsFor: 'code generation'!
emitForReturn: stack on: strm

	expr emitForReturn: stack on: strm.
	pc _ strm position! !

!ReturnNode methodsFor: 'code generation'!
emitForValue: stack on: strm

	expr emitForReturn: stack on: strm.
	pc _ strm position! !

!ReturnNode methodsFor: 'code generation'!
pc
	"Used by encoder source mapping."

	^pc! !

!ReturnNode methodsFor: 'code generation'!
sizeForReturn: encoder

	^expr sizeForReturn: encoder! !

!ReturnNode methodsFor: 'code generation'!
sizeForValue: encoder

	^expr sizeForReturn: encoder! !


!ReturnNode methodsFor: 'printing'!
printOn: aStream indent: level

	aStream nextPutAll: '^ '.
	expr printOn: aStream indent: level.
	expr printCommentOn: aStream indent: level! !


!ReturnNode methodsFor: 'C translation' stamp: 'jm 11/15/2003 04:51'!
asTranslatorNode

	^ TReturnNode new setExpression: expr asTranslatorNode
! !


!ReturnNode methodsFor: 'elements' stamp: 'jens 1/30/2009 00:31'!
asSyntaxElement

	^ReturnElementMorph new expression: expr asSyntaxElement! !
