ArgMorph subclass: #BooleanArgMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scratch-Blocks'!

!BooleanArgMorph methodsFor: 'initialization' stamp: 'jm 3/28/2005 16:33'!
initialize

	super initialize.
	self color: (Color r: 0.451 g: 0.866 b: 0.109).
	self extent: 25@13.
! !


!BooleanArgMorph methodsFor: 'drawing' stamp: 'jm 3/28/2005 16:42'!
drawOn: aCanvas 

	| h s v darkerC lighterC right topY bottomY xInset c |
	h _ color hue.
	s _ color saturation.
	v _ color brightness.
	darkerC _ Color h: h s: (s - 0.3) v: (v - 0.3).
	lighterC _ Color h: h s: (s - 0.2) v: (v + 0.2).

	right _ self width.
	topY _ bottomY _ self height // 2.
	self height even ifTrue: [topY _ bottomY - 1].
	xInset _ 0.
	[topY >= 0] whileTrue: [
		self drawHLineFrom: xInset to: (xInset + 2) y: topY color: darkerC on: aCanvas.
		c _ (topY <= 1) ifTrue: [darkerC] ifFalse: [color].
		self drawHLineFrom: xInset + 2 to: right - (xInset + 1) y: topY color: c on: aCanvas.
		self drawHLineFrom: (right - (xInset + 1)) to: (right - xInset) y: topY color: darkerC on: aCanvas.

		self drawHLineFrom: xInset to: (xInset + 1) y: bottomY color: lighterC on: aCanvas.
		c _ (bottomY >= (self height - 2)) ifTrue: [lighterC] ifFalse: [color].
		self drawHLineFrom: xInset + 1 to: right - (xInset + 1) y: bottomY color: c on: aCanvas.
		self drawHLineFrom: (right - (xInset + 2)) to: (right - xInset) y: bottomY color: lighterC on: aCanvas.

		xInset _ xInset + 1.	
		bottomY _ bottomY + 1.
		topY _ topY - 1].

! !

!BooleanArgMorph methodsFor: 'drawing' stamp: 'jm 3/28/2005 16:03'!
isRectangular

	^ false
! !


!BooleanArgMorph methodsFor: 'other' stamp: 'jm 7/7/2004 00:24'!
acceptsDroppedReporters

	^ true
! !

!BooleanArgMorph methodsFor: 'other' stamp: 'jens 11/16/2009 00:37'!
acceptsTypeOf: aBlockMorph
	"Answer true if I can accept a dropped reporter of the givent type."

	^ aBlockMorph isBooleanReporter or: [
		aBlockMorph isAbstractFunctionCall ]
! !

!BooleanArgMorph methodsFor: 'other' stamp: 'jens 7/21/2010 19:21'!
fixArgLayout
	"Set my color to my owner's color."

	self color: (owner color mixed: 0.7 with: (Color gray: 0.4)).

! !

!BooleanArgMorph methodsFor: 'other' stamp: 'jm 8/31/2006 09:17'!
printArgOn: aStream
	"Print this argument morph on the given stream."

	aStream nextPutAll: 'false'.
! !


!BooleanArgMorph methodsFor: 'evaluation' stamp: 'jens 2/1/2010 21:20'!
evaluate
	"Answer false by default."

	(self isEmptySlot and: [implicitValue notNil])
		ifTrue: [^implicitValue].

	^ false
! !
